/*
	Write & edit by Linjianghua
	Copyright Linjianghua
	Reserve all rights
*/

#include "c_lib.def"

extern char **environ;
char **envpath(const char *prgpath, const char *defpath)
{
/* prgpath is *_argv, so progpath is nozero, free progpath when have init */
char *prg, *pt, *ptr, **pms=NULL;
#ifdef		_STDIO_H
static char div[]=";,:";
#define dysb  ':'
#else
static char div[]=";,";
#define dysb  ';'
#endif
int i;
prg=strdup(prgpath);
ptr=prg;
pt=strrchr(prg,ROOT_CH);
if(pt)*pt=0; 
if(defpath){
	prg=catstr(ptr, defpath, dysb);
	free(ptr);	ptr=prg;
}
#define PATH_LEN  5  /* strlen("PATH=") */
for(i=0;(pt=environ[i])!=NULL;i++){
   if(strstr(pt,"PATH=")==pt){
	  int plen=strlen(prg);
	  char  *pt2=memstr(pt,0,prg,plen,1);
	  pt=catstr(prg, (pt2&& (pt2==pt||strchr(div,pt2[-1])) &&memchr(div,pt2[plen],sizeof(div)) ? SPC:pt+PATH_LEN), dysb);
	  FmtInput(pt,&cnt_path,div, dysb); /* get cnt_path */
	  pms=MemDiv(pt,div,cnt_path);
	  break;
   }
}
free(ptr);
return pms;
}
