/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008,2009 Linjianghua(xempo).
  All Rights Reserve.
  email : xempo@189.cn
*/

#include <time.h>
#include "sbl.def"
const char Verchs[]=" V",
SBLver[]="Struct Bin Lib 1.61", SBLext[]=".sbl",
SBLtag[28]={'e','X','e','c','u','t','i','n','g',32,'B','i','n','a','r','y',32,
'V','0','0','0','0',13,26};
int SBLmsg; /* all kind of msg for NumbScan, include creatdir msg,
 >0x7ffe is success, other is (err)msg index */
char ScanBuf[560], **BinDat;
const char memblkcmp[6]={10,13,0, ',' , ';' },/* don't change sort */
SBLfver[dir_style_cnt][5]={ "V1.1", "V1.2", "V1.3" },
_ver[dir_style_cnt][4]={ 0,18,55,0,  1,24,60,0,
2,32,74,0 };
/* ver, sbl-dsk, dir-siz, mdf(no-use) */

int (*popMsg)(char *,char *,int);

void dkwrite(_SBL *xbl,void *dat,size_t datlen,_Long pos)
{
fseek(xbl->fpt,pos,0);
fwrite(dat,datlen,1,xbl->fpt);
}

unsigned int dkread(_SBL *xbl,void *dat, unsigned int len, unsigned int cnt,_Long pos)
{
fseek(xbl->fpt,pos,0);
return fread(dat,len,cnt,xbl->fpt);
}

void GetSBLver(char *chs,char *buf,const char *fnd)
{
  char *pt=strstr(chs,fnd);
  if(pt){ 
    char *ptr=strchr(pt,'\r');
    if(ptr)*ptr=0;
    strcpy(buf,pt+1);
  }
}

void ChgFlgs(_SBL *xbl,SBLdir *Dir,int cnt,int xblmsg,int dirmsg)
{
xbl->mdf|=xblmsg;	Dir->mdf|=dirmsg;
if(cnt){ xbl->cn+=cnt;	Dir->cn+=cnt; }
}

void CreatSeg(_SBL *pblk,SBLdir *Dir)
{
int len=Dir->statLen*Dir->PreAlloc +4;
void *dat=memset(malloc(len),0,len);
dkwrite(pblk,dat,len,pblk->fsz);
pblk->fsz+=len; pblk->use+=len;
Dir->sz+=len;
free(dat);
}

void SBLdestory(_SBL *pt)
{
if(pt/*&&pt->fpt*/){
  if(pt->cDir&&(pt->mdf||pt->adr!=pt->cDir->pOwn)){
    time_t tm;
    pt->adr=pt->cDir->pOwn;
    pt->date=time(&tm);
    dkwrite(pt,&pt->DirAdr,pt->SBLsize,BSlen);
	}
if(pt->cDir)LDirClose(pt,pt->cDir);
free(pt->fname);
fclose(pt->fpt);
free(pt);
}
}

_SBL *SBLopen(char *fnam, int brw)
{
int i , errNo=0;
FILE *fp;
char descpt[32],  *oldfnam=fnam;
_SBL *pblk=SBLalloc();
ropen: fp=PathOpen(fnam,"rb+");
if(fp==NULL){
  if(errNo==1){ free(fnam); fnam=oldfnam; goto _type_;	}
catExt:	if(oldfnam==fnam && memstr(fnam,0,SBLext,5,0)==NULL){
		fnam=catstr(fnam,SBLext,false);
		goto ropen;
		}
ex:	if(brw)KShowMsg(oldfnam,BinDat[errNo],1);
	if(fnam!=oldfnam)free(fnam);
	free(pblk);	return NULL;
	}
else {
	fread(descpt,BSlen,1,fp);
	if(memstr(descpt,BSlen,SBLtag,Btaglen,3)==NULL
	  &&memstr(descpt,BSlen,"Storage Plus Lib V",Btaglen,3)==NULL){
		errNo=1;
		if(oldfnam==fnam){ fclose(fp); goto catExt; }
		else _type_: {	int n=atoi(BinDat[12]);
			char **ptrs, *ptr;
			if((ptr=strchrs(BinDat[13],memblkcmp))!=NULL)*ptr=0;
			if(access(BinDat[13],6))goto _Exit_;
			ptrs=GetDscpt(BinDat[13],n);	n/=2;
			for(i=0;i<n;i++)if(memstr(descpt,BSlen,ptrs[i],Btaglen,2)){
				popMsg(ptrs[n+i],fnam,0);	brw=0;
				break;
				}
			if(ptrs[1]!=*ptrs)free(*ptrs);
			free(ptrs);
			goto _Exit_;
		}
	}
	GetSBLver(descpt,pblk->ver,Verchs);
	*(_Long *)pblk=descpt[24]<10? *(_Long *)(descpt+24):*(_Long *)_ver[0];
	if(fread(&pblk->DirAdr,pblk->SBLsize,1,fp)<1){
	errNo=5;
	_Exit_:    fclose(fp);
	goto ex;
	}
}
fseek(fp,0,2); pblk->fsz=ftell(fp);
pblk->fpt=fp;
pblk->fname=oldfnam!=fnam? fnam:strdup(oldfnam);
return pblk;
}

_Long NumbScan(_SBL *xbl,SBLdir *Dir,_Long numb,int flg)
{
_Long *p_Long, rt, seg, pos;
char *segs_buf, *pcell, *pDAU;
unsigned char flags;
unsigned _Int clen;
time_t tm;
_Int len, i, j, flagpos, len1, len2;
DAU *pdk, *pdk1, *parm_DAU;
if(xbl==NULL||Dir==NULL/*||xbl->fpt==NULL*/){
	SBLmsg=xbl? 4:2; return MSG_NO_NUMB;
	}
SBLmsg=0x7fff;
clen=Dir->statLen;	rt=flg;
flagpos=Dir->datelog? 8:4;
parm_DAU=(DAU *)(ScanBuf+flagpos+1);
seg = flg!=SBL_LIST? Dir->hdadr:Dir->nx_seg;
if(seg==0){
  if(flg==SBL_WRITE){
	Dir->hdadr=xbl->fsz;
	CreatSeg(xbl,Dir);
	return Dir->hdadr;
	}
SBLmsg=4;
return MSG_NO_NUMB;
}
len=Dir->PreAlloc*clen+4;
segs_buf=(char *)malloc(len);
p_Long=(_Long *)(segs_buf+len-4);
while( seg>0 ){
if(dkread(xbl,segs_buf,len,1,seg)<1){ SBLmsg=5; goto ExitScan; }

#ifndef _K_RUNTIME_
/* _K_RUNTIME use DOS */
if(flg==SBL_LIST){ Dir->nx_seg=*p_Long; return (_Long)segs_buf; }
#endif

for(i=0,j=0; i<Dir->PreAlloc; i++,j+=clen){
   pos=seg + j;
   pcell=segs_buf + j;
   flags=pcell[flagpos];
   switch( flags ){
   case 1 :
	if(numb==*(_Long *)pcell)switch(flg){
		case SBL_WRITE : rt=-pos;
		case SBL_READ :
		case SBL_DEL :	/* del need calc size */
			segread: memcpy(ScanBuf,pcell,clen);
			goto outloop;
		}/* sw */
	break;
   case 0 : if(rt<0&&flg==SBL_WRITE)rt=pos;/* only init */
		break;
   default : switch(flg){
	  case SBL_WRITE :
	  if(Dir->datelog&&time(&tm)-*(unsigned _Long *)(pcell+4)<0xffff)break;
	  pDAU=pcell+clen;	len2=-1;
	  if(clen>sg_dat){ pdk1=(DAU *)(pDAU-8);
	Retry:	len2=pdk1->len-parm_DAU[1].mlen;
		}
	  pdk=(DAU *)(pDAU-8);
	  len1=pdk->len-parm_DAU->mlen;
	  if(rt<0 && flags!=Dir->flg){
	    if( (len1>0&&len1<2048 || len2>0&&len2<2048) || (
		pdk->len<1024&&(Dir->dau<2||pdk1->len<1024)) ){
		    memcpy(ScanBuf,pcell,clen);
		    *(_Long *)ScanBuf=numb;
		    rt=pos;
		    }
	    else if(Dir->dau>1){
		DAU dau=*pdk;
		*pdk=*pdk1; *pdk1=dau;
		goto Retry;
			}
	  }
		break;
#ifndef _K_RUNTIME_
	  case SBL_UNDO : if(flags==Dir->flg)goto intoRescu;
		break;
	  case SBL_RESCU :
	    if(flags!=Dir->flg){
		intoRescu: rt=pos;
		goto segread;
		}
#endif
	  }/* sw */	/* follow is flags=0 */
	}
   }
seg=*p_Long;
}
/* here must end, Callers process self-data */
outloop:switch(flg){
	case SBL_READ:
/*	if(i>=Dir->PreAlloc)SBLmsg=4;	break;*/
	case SBL_DEL:
	if(i<Dir->PreAlloc)rt=pos;
	else SBLmsg=4;
	break;
	case SBL_WRITE :
	if( /*i>=Dir->PreAlloc &&*/ rt==SBL_WRITE ){
		rt=xbl->fsz;
		dkwrite(xbl,&rt,4,pos+clen);
		CreatSeg(xbl,Dir);
		}
	}
ExitScan: free(segs_buf);
return rt;/* stat-pos ... */
}

void calcLen(MAU *pdat)
{
if(pdat->buf==NULL)pdat->len=0;
else if(pdat->len==0)pdat->len=strlen(pdat->buf);
if(pdat->len>0xfffe)pdat->len=0xfffe;
}

void GetDAU(_SBL *lib,MAU *mau,DAU *dau)
{
if(mau && dau->len ){
size_t cn;
mau->buf=(char *)malloc( dau->len + 2 );
fseek(lib->fpt,dau->adr,0);	cn=fread(mau->buf,1,dau->len,lib->fpt);
if(cn<dau->len)popMsg(BinDat[3],NULL,1);
mau->len=cn;
mau->buf[cn]=0;
}
}

char *GetNumb(_SBL *xbl,SBLdir *Dir,_Long nmb,MAU *send1,MAU *send2,int qfg)
{
char *buf=ScanBuf;
if(NumbScan(xbl,Dir,nmb,SBL_READ)>0/*SBLmsg>0x7ffd*/){
  int len;
  for(len=Dir->statLen-8;len>4;len-=8)
	if(len<21)GetDAU(xbl,len>9? send2:send1,(DAU *)(buf+len));
  return buf;
	}

sprintf(buf,"%ld",nmb);
if(qfg)popMsg(BinDat[SBLmsg], buf, 1|STYLE);
return NULL;
}

int PutDAU(_SBL *xbl,SBLdir *Dir,char flg,DAU *dau,MAU *wtdat)
{
if(wtdat&&wtdat->buf){
  unsigned int wtLen=wtdat->len;
  if(flg==1){ /* overwrite */ Dir->sz-=dau->mlen; xbl->use-=dau->mlen; }
  if(dau->len<wtLen){
	dau->adr=xbl->fsz;
	xbl->fsz += wtLen;
	dau->len=wtLen;
  }
  dau->mlen=wtLen;/* set current len */
  Dir->sz+=wtLen;/*!! sz is Dir data's USEFUL size */
  xbl->use+=wtLen;
  dkwrite(xbl,wtdat->buf,wtLen,dau->adr);
  return 1;
  }
return 0;
}

void WriteStat(_SBL *xbl, SBLdir *Dir, char *dat, char ch, _Long pos)
{
time_t tm;
if(Dir->datelog){ dat[8]=ch; *(_Long *)(dat+4)=time(&tm); }
else dat[4]=ch;
dkwrite(xbl,dat,Dir->statLen,pos);
}

char *SetNumb(_SBL *xbl,SBLdir *Dir,_Long nmb,MAU *send1,MAU *send2,int qfg)
{
_Long pos;
MAU *mau;
int msg=0;
unsigned int clen=Dir->statLen;
if(nmb<MSG_NO_NUMB+1){
	SBLmsg=4;
	ExitPrg: popMsg(BinDat[SBLmsg],NULL,1|STYLE);
	return NULL;
	}
memset(ScanBuf,0,clen);/* 2 adr must set 0  / ?? 2008: needn't?! */
pos=NumbScan(xbl,Dir,nmb,SBL_WRITE);
if(SBLmsg<0x7ffe)goto ExitPrg;
if(pos<0 && (qfg&1) && popMsg(BinDat[8],NULL,128|STYLE)!=XbiYES)return NULL;
while( (clen-=8)>4)
  if(clen<21&&(mau=clen>9? send2:send1)!=NULL){
  calcLen(mau);
  msg+=PutDAU(xbl,Dir, pos<0? 1:0, (DAU *)(ScanBuf+clen), mau);
 }
if(msg==0)return NULL;
*(_Long *)ScanBuf=nmb;
WriteStat(xbl,Dir,ScanBuf, 1, pos>0? pos:-pos);
ChgFlgs(xbl,Dir,pos>0?1:0,1,1);
return ScanBuf;
}

void FixStat(_SBL *sbl,SBLdir *Dir1,int step,int dirmsg,_Long pos)
{
int msg=Dir1->statLen;
_Long siz;
while( (msg-=8)> 4 ){	/* from DAU[1] to DAU[0] */
  siz=(_Long) step * ((DAU *)(ScanBuf+msg))->mlen; /* as mlen is	unsigned _Int, overflow, so use _Long ...*/
  Dir1->sz+=siz;
  sbl->use+=siz;
  }
WriteStat(sbl,Dir1,ScanBuf, step>0? 1 : Dir1->flg, pos);
ChgFlgs(sbl,Dir1,step,1,dirmsg);
}

int DelNumb(_SBL *sbl, SBLdir *dir, _Long numb)
{
/* _Long pos=;*/
if(SBLmsg>0x7ffd)FixStat(sbl,dir,-1,8/* use for dirclose*/, NumbScan(sbl,dir,numb,SBL_DEL));
return SBLmsg;
}
