/*
  Designed by LinJiangHua(xempo) 2004-2006,2008,2009
  Copyright 2004-06 Linjianghua(xempo).
  All Rights Reserve.
*/
#include "sbl.def"

#define IsEmpty(sbl,dir) LDirFix(sbl,p_DirFlags,dir)

bool IsInPath(_SBL *sbl,SBLdir *dir,SBLdir *chkdir)
{
_Long adr=0;
if(dir==NULL)return false;
if(chkdir){
  SBLdir *pdir=chkdir;
  adr=pdir->pOwn;
  while(adr!=dir->pOwn&&(adr=pdir->parDir)>0){
	if(pdir!=chkdir)CatchClose(sbl,pdir);
	pdir=DirRead(sbl,adr);
  }
  if(pdir!=chkdir)CatchClose(sbl,pdir);
}
return (adr==dir->pOwn);
}

void *ReGetDir(_SBL *pblk,SBLdir *Dir,int strmsg)
{
if(Dir){
char *pth=NULL, *pchs, *pchs2;
_Long adr;
SBLdir *ptdir=pblk->cDir;
if(Dir->parDir<=0)return(strmsg? (void *)catstr(p_DirFlags,Dir->name,false):Dir);

adr=Dir->parDir;
do{
  if(ptdir!=pblk->cDir)free(ptdir);
  ptdir=DirRead(pblk,adr);
  adr=ptdir->parDir;
  if(strmsg){
	pchs=catstr(p_DirFlags,ptdir->name,false);
	if(pth==NULL)pth=catstr(pchs,Dir->name,true);
	else {
		pchs2=pth; pth=catstr(pchs,pth,false);
		free(pchs2);
		}
	free(pchs);
	}
}while(adr>0);
if(strmsg){ 
	if(ptdir!=pblk->cDir)free(ptdir); 
	return pth;
	}
return ptdir;
}
return NULL;
}

void RemoveDir(_SBL *sbl,SBLdir *pDir0,SBLdir *dir,int step)
{
SBLdir *pdir;
time_t tm;
_Long siz=dir->sz+sbl->DirSize;
dir->usemsg=step>0? 1:2;
dir->date=time(&tm);
dkwrite(sbl,dir,DirFlagPos,dir->pOwn);
sbl->Dircn+=step;	sbl->mdf|=1;
if(sbl->Ver){
  if(dir->parDir){
     if(pDir0==NULL||dir->parDir!=pDir0->pOwn){
	  pdir=DirRead(sbl,dir->parDir);
	  pdir->dircnt+=step;	pdir->sz+=step*siz;
	  pdir->mdf=1;
	  LDirClose(sbl,pdir);
	  }
     else { pDir0->mdf|=1;
	    pDir0->dircnt+=step; pDir0->sz+=step*siz;
		}
	 }
  else sbl->rootcn+=step;
	}
}

void LDirModify(_SBL *sbl,char *oldNam,char *newNam)
{/* newNam=NULL is Del, nor Rename */
SBLdir *Dir=LDirOpen(sbl,oldNam);
if(Dir){
  SBLdir *tstdir,
  *pDir0=Dir->parDir? DirRead(sbl,Dir->parDir):NULL;
  if(newNam){/* rename */
     _Long adr=Dir->parDir? pDir0->subDir:sbl->DirAdr;
     tstdir=LDirFix(sbl,newNam,adr);
     if(tstdir){
	popMsg(BinDat[10],newNam,1);
	CatchClose(sbl,tstdir);
	}
     else if(NameCopy(Dir->name,newNam,sbl->Ver? DirNamLen:18))Dir->mdf|=1;
	  else puts(BinDat[SBLmsg]);
  }
  else {/* deldir */
    if(IsInPath(sbl,Dir,sbl->cDir))puts(usagMsg[17]);
    else {
	tstdir=IsEmpty(sbl,Dir->subDir);/* test dir empty */
	if(tstdir){ free(tstdir); puts(usagMsg[2]); }
	else RemoveDir(sbl,pDir0,Dir,-1);
	}
    }
  CatchClose(sbl,pDir0);
  CatchClose(sbl,Dir);
    }
}
